/*
 *  File Name: VLIST.H
 *
 *  Permission to use, copy, modify, and distribute this software
 *  for NON-COMMERCIAL purposes and without fee is hereby granted
 *  provided that this notice and the copyright notice below appear
 *  in all copies.
 *
 *  This software is adapted from the text
 *
 *      "Inside the Object Model: The Sensible Use of C++"
 *              by David M. Papurt,
 *                  published by SIGS Books
 *                      ISBN 1-884842-05-4
 *
 *  DAVID PAPURT MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY
 *  OF THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED
 *  TO THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 *  PURPOSE, OR NON-INFRINGEMENT. DAVID PAPURT SHALL NOT BE LIABLE FOR
 *  ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING, OR
 *  DISTRIBUTING THIS SOFTWARE OR ITS DERIVATIVES.
 * 
 *  THIS SOFTWARE IS NOT DESIGNED OR INTENDED FOR USE OR RESALE AS ON-LINE
 *  CONTROL EQUIPMENT IN HAZARDOUS ENVIRONMENTS REQUIRING FAIL-SAFE
 *  PERFORMANCE, SUCH AS IN THE OPERATION OF NUCLEAR FACILITIES, AIRCRAFT
 *  NAVIGATION OR COMMUNICATION SYSTEMS, AIR TRAFFIC CONTROL, DIRECT LIFE
 *  SUPPORT MACHINES, OR WEAPONS SYSTEMS, IN WHICH THE FAILURE OF THE
 *  SOFTWARE COULD LEAD DIRECTLY TO DEATH, PERSONAL INJURY, OR SEVERE
 *  PHYSICAL OR ENVIRONMENTAL DAMAGE ("HIGH RISK ACTIVITIES").  DAVID PAPURT
 *  SPECIFICALLY DISCLAIMS ANY EXPRESS OR IMPLIED WARRANTY OF FITNESS FOR
 *  HIGH RISK ACTIVITIES.
 *
 *  Copyright (c) 1995, 1996 by David M. Papurt. All Rights Reserved.
 *
 */

#ifndef VLIST_H
#define VLIST_H

class VLink
{
	friend class VList;
	VLink * next;
	void * data;

	VLink( void * d, VLink * n );
};

class VList
{
	VLink * c;			// iterator currency
	VLink * head;

public:

	VList();
	~VList();

	void insert( void * p );
		// insert at head
	void * remove();
		// remove from head,
		// returns element, or 0 if empty
	void * remove( void * p );
		// remove element addressed by p,
		// returns p, or 0 if p not found
	void * get();
		// get at head without removal,
		// returns head element, or 0 if empty

	void reset();
	void * next();
		// iteration

	int isIn( void * p );
		// TRUE if p in VList,
		// FALSE otherwise
};

#endif
  // VLIST_H
