/*
 *  File Name: TESTMULT.CPP
 *
 *  Permission to use, copy, modify, and distribute this software
 *  for NON-COMMERCIAL purposes and without fee is hereby granted
 *  provided that this notice and the copyright notice below appear
 *  in all copies.
 *
 *  This software is adapted from the text
 *
 *      "Inside the Object Model: The Sensible Use of C++"
 *              by David M. Papurt,
 *                  published by SIGS Books
 *                      ISBN 1-884842-05-4
 *
 *  DAVID PAPURT MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY
 *  OF THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED
 *  TO THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 *  PURPOSE, OR NON-INFRINGEMENT. DAVID PAPURT SHALL NOT BE LIABLE FOR
 *  ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING, OR
 *  DISTRIBUTING THIS SOFTWARE OR ITS DERIVATIVES.
 * 
 *  THIS SOFTWARE IS NOT DESIGNED OR INTENDED FOR USE OR RESALE AS ON-LINE
 *  CONTROL EQUIPMENT IN HAZARDOUS ENVIRONMENTS REQUIRING FAIL-SAFE
 *  PERFORMANCE, SUCH AS IN THE OPERATION OF NUCLEAR FACILITIES, AIRCRAFT
 *  NAVIGATION OR COMMUNICATION SYSTEMS, AIR TRAFFIC CONTROL, DIRECT LIFE
 *  SUPPORT MACHINES, OR WEAPONS SYSTEMS, IN WHICH THE FAILURE OF THE
 *  SOFTWARE COULD LEAD DIRECTLY TO DEATH, PERSONAL INJURY, OR SEVERE
 *  PHYSICAL OR ENVIRONMENTAL DAMAGE ("HIGH RISK ACTIVITIES").  DAVID PAPURT
 *  SPECIFICALLY DISCLAIMS ANY EXPRESS OR IMPLIED WARRANTY OF FITNESS FOR
 *  HIGH RISK ACTIVITIES.
 *
 *  Copyright (c) 1995, 1996 by David M. Papurt. All Rights Reserved.
 *
 */

#include <iother.h>
#include <cother.h>
#include <wother.h>
#include <a1_1_bif.cpp>
#include <iostream.h>

typedef L1to1<IOther,COther> InvToCon;
typedef R1to1<IOther,COther> Contraption;

typedef L1to1<WOther,InvToCon> Workshop;
typedef R1to1<WOther,InvToCon> Inventor;

void print( Inventor & I )
{
	cout << "\n\nInventor: " << I.name();

	cout << "\nInvention: ";
	if ( I.InvToCon::follow() )
		cout << I.InvToCon::follow()->title();
	else
		cout << "None!";

	cout << "\nWorkshop Location: ";
	if ( I.Inventor::follow() )
		cout << I.follow()->address();
		// Scoping not strictly necessary
	else
		cout << "None!";
}

int main()
{
	Inventor i;
	i.name( "Dave" );
	Contraption c;
	c.title( "Medical Device" );
	Workshop w;
	w.address( "Home" );

	link( (InvToCon &)i, c );
	link( w, (Inventor &)i );
		// Casts not strictly necessary
	print( i );

	unlink( (InvToCon &)i );
	print( i );

	return 0;
}

