/*
 *  File Name: TEST.CPP
 *
 *  Permission to use, copy, modify, and distribute this software
 *  for NON-COMMERCIAL purposes and without fee is hereby granted
 *  provided that this notice and the copyright notice below appear
 *  in all copies.
 *
 *  This software is adapted from the text
 *
 *      "Inside the Object Model: The Sensible Use of C++"
 *              by David M. Papurt,
 *                  published by SIGS Books
 *                      ISBN 1-884842-05-4
 *
 *  DAVID PAPURT MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY
 *  OF THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED
 *  TO THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 *  PURPOSE, OR NON-INFRINGEMENT. DAVID PAPURT SHALL NOT BE LIABLE FOR
 *  ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING, OR
 *  DISTRIBUTING THIS SOFTWARE OR ITS DERIVATIVES.
 * 
 *  THIS SOFTWARE IS NOT DESIGNED OR INTENDED FOR USE OR RESALE AS ON-LINE
 *  CONTROL EQUIPMENT IN HAZARDOUS ENVIRONMENTS REQUIRING FAIL-SAFE
 *  PERFORMANCE, SUCH AS IN THE OPERATION OF NUCLEAR FACILITIES, AIRCRAFT
 *  NAVIGATION OR COMMUNICATION SYSTEMS, AIR TRAFFIC CONTROL, DIRECT LIFE
 *  SUPPORT MACHINES, OR WEAPONS SYSTEMS, IN WHICH THE FAILURE OF THE
 *  SOFTWARE COULD LEAD DIRECTLY TO DEATH, PERSONAL INJURY, OR SEVERE
 *  PHYSICAL OR ENVIRONMENTAL DAMAGE ("HIGH RISK ACTIVITIES").  DAVID PAPURT
 *  SPECIFICALLY DISCLAIMS ANY EXPRESS OR IMPLIED WARRANTY OF FITNESS FOR
 *  HIGH RISK ACTIVITIES.
 *
 *  Copyright (c) 1995, 1996 by David M. Papurt. All Rights Reserved.
 *
 */

#include <iother.h>
#include <cother.h>
#include <pother.h>
#include <a1_m_bia.cpp>
#include <iostream.h>

typedef AT1toM<IOther,POther,COther> Patent;
typedef LT1toM<IOther,POther,COther> Inventor;
typedef RT1toM<IOther,POther,COther> Contraption;

void print( Inventor & I )
{
	cout << "Inventor: "
	     << I.name()
	     << '\n'

	     << "Inventions:\n";

	I.reset();
	Patent * p;
	while( (p=I.assoc())  !=  0 )
	{
		cout << " Patent No. "
		     << p->number()
		     << ", Title: "
		     << p->right()->title()
		     << '\n';
	}
	cout << '\n';
}

int main()
{
	Inventor * i = new Inventor;
	i->name("Dave");

	Contraption * c1 = new Contraption;
	c1->title("Measuring Device");
	Contraption * c2 = new Contraption;
	c2->title("Safety Device");

	Patent * p1 = new Patent( *i, *c1 );
	p1->number( 4678337L );
	Patent * p2 = new Patent( *i, *c2 );
	p2->number( 5070890L );

	print( *i );

	delete i;
	delete c1;
	delete c2;

	return 0;
}


